#ifndef DATADIR
#define DATADIR "/usr/local/share/atr"
#endif

#ifdef WINDOWS
#define DATADIR "."
#endif

#define MAX_PLAYERNAME_LENGTH 20
#define MAX_PLAYERS 32
#define MAX_FILENAME_SIZE 80
#define MAX_NAME_LENGTH 80
#define NUM_THREADS 5
#define NUM_GAME_TYPES 3
#define TRUE 1
#define FALSE 0
#define MAX_WORLD_WIDTH 65535
#define MAX_WORLD_HEIGHT 65535
#define MIN_WORLD_WIDTH 320
#define MIN_WORLD_HEIGHT 240
#define MAX_PORT_VALUE 65535
#define NUM_SHIP_PHASES 48
#define STATUS_SEND_TYPE 0
#define SHIP_SEND_TYPE 1
#define OBJ_SEND_TYPE 2
#define SOUND_SEND_TYPE 3
#define MAX_SHOTS 18
#define MAX_SHOT_SPEED 256
#define MAX_SLEEP_TIME 1000
#define MAX_OBJECTS 255
#define SHIP_TYPE 1
#define SHIP_SIZE 32
#define SHIP_WEIGHT 32
#define SHOT_TYPE 2
#define SHOT_SIZE 4
#define SHOT_WEIGHT 4
#define BIGROCK_TYPE 3
#define BIGROCK_SIZE 32
#define BIGROCK_WEIGHT 64
#define MEDIUMROCK_TYPE 4
#define MEDIUMROCK_SIZE 32
#define MEDIUMROCK_WEIGHT 32
#define SMALLROCK_TYPE 5
#define SMALLROCK_SIZE 16
#define SMALLROCK_WEIGHT 16
#define SHRAPNEL1_TYPE 6
#define SHRAPNEL2_TYPE 7
#define SHIPEXPLOSION_TYPE 8
#define EXPLOSION_TYPE 9
#define PRIZE_TYPE 10
#define PRIZE_SIZE 32
#define VORTEX_TYPE 11
#define VORTEX_SIZE 32
#define VORTEX_WEIGHT 0
#define STEELROID_TYPE 12
#define STEELROID_SIZE 32
#define STEELROID_WEIGHT 32
#define NUM_TYPES 32
#define SINGLE_PLAYER 0
#define FREE_FOR_ALL 1
#define DEATHMATCH 2
#define SAFE_DISTANCE 100
#define NUM_PRIZE_TYPES 6
#define TRIPLE_SHOT 1
#define SHIELD_PRIZE 2
#define LUCK_OF_THE_IRISH 3
#define LUCK_ODDS 2
#define AUTOFIRE 4
#define LONGFIRE 5
#define SPEEDUP 6
#define MAX_PACKET_SIZE 10240

typedef struct {
  char GameOn;
  short GameType;
  short MaxPlayers;
  short PlayerNum;
  short WorldWidth, WorldHeight;
  long MaxShield;
} GameParametersStruct;

typedef struct {
  bool thrusting;
  bool left;
  bool right;
  bool shooting;
  bool shield;
} PlayerActionStruct;

typedef struct {
  long x, y;
  short phase;
  short ShieldValue;
  unsigned char playernum;
  unsigned long score;
  char alive;
  char TripleShot;
  char LuckOfTheIrish;
  char AutoFire;
  char LongFire;
  char Speedup;
  unsigned char lives;
  char ShieldOn;
  char PlayerName[MAX_PLAYERNAME_LENGTH];
} ShipDataStruct;

typedef struct {
  char type;
  short objnum;
  long x, y;
} ObjDataStruct;

typedef struct {
  char type;
  long x, y;
} SoundStruct;

typedef struct {
  char ThrustKey;
  char RightKey;
  char LeftKey;
  char ShieldKey;
  char FireKey;
  char AbortKey;
} KeyValuesStruct;
