#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sounddefs.h"
#include "defines.h"

// Time in milliseconds between frames
#define FRAME_DELAY		20

#define MAX_SPRITE_FRAMES	60
#define	NUM_STARS		30
#define	SHIP_FRAMES		48
#define	MAX_SPRITE_SIZE       	64
#define MAX_BLITS               200
#define NUM_MAINMENU_ITEMS      8
#define NUM_CONFMENU_ITEMS      16
#define NUM_SERVMENU_ITEMS      38
#define NUM_SCOREMENU_ITEMS     2
#define MAX_MENU_ITEMS          50

typedef struct {
  int h, v;
} MPoint;

typedef struct {
  char Thrust, Right, Left, Fire, Shield, Score, Quit;
} ControlStruct;

typedef	struct {
  int Frames;
  unsigned long Width, Height;
  unsigned char *pixels[MAX_SPRITE_FRAMES];
} Sprite;

typedef struct {
  unsigned long xpos, ypos;
  unsigned long Width, Height;
  unsigned char *pixels;
} Blit;

typedef struct {
  float red, green, blue;
} Color;

typedef struct {
  long xpos, ypos;
  Color StarColor;
} Star;

extern int Lives;
extern int myShip;
extern int GameOver;
extern int GameType;
extern int NumPlayers;
extern int BoomDelay;
extern int NextBoom;
extern int BoomPhase;
extern char PlayerName[MAX_PLAYERNAME_LENGTH];
extern int ShowScore;
extern int GameStop;

#define true	1
#define false	0

// in init.cc : 
extern MPoint ThrustOrigins[SHIP_FRAMES];

// The blitters we use
extern Sprite *BigRockSprite, *MediumRockSprite, *SmallRockSprite,
  *DamagedShipSprite, *ShipExplosionSprite, *MultiplierSprite[], *ShipSprite,
  *ExplosionSprite, *NovaSprite, *EnemyShipSprite, *EnemyShip2Sprite,
  *SteelRoidSprite, *PrizeSprite, *BonusSprite, *PointSprite,
  *VortexSprite, *HomingMineSprite, *ShieldSprite, *Thrust1Sprite,
  *Thrust2Sprite, *Shrapnel1Sprite, *Shrapnel2Sprite, *ShotSprite,
  *TripleIconSprite, *LuckIconSprite, *AutoFireIconSprite, *LongFireIconSprite,
  *SpeedupIconSprite;
