#include <GL/glut.h>


#include "ship.h"
#include "network.h"
#include "objglobals.h"
#include "netdata.h"
#include "key.h"
#include "menu.h"
#include "thread.h"
#include "score.h"
#include "clientconfig.h"
#include "serverconfig.h"


void KeyDown(unsigned char key, int x, int y);
void KeyUp(unsigned char key, int x, int y);
void MainMenuSpecialKey(int key, int x, int y);
void ConfMenuSpecialKey(int key, int x, int y);
void ServMenuSpecialKey(int key, int x, int y);
void ScoreMenuSpecialKey(int key, int x, int y);
void MainMenuKey(unsigned char key, int x, int y);
void ServMenuKey(unsigned char key, int x, int y);
void ScoreMenuKey(unsigned char key, int x, int y);
void SetKeyValueKey(unsigned char key, int x, int y);
void TextEntryKey(unsigned char key, int x, int y);
void ScoreEntryKey(unsigned char key, int x, int y);
void IntTextEntryKey(unsigned char key, int x, int y);
void ServIntTextEntryKey(unsigned char key, int x, int y);


ControlStruct controls;


// Function to handle key presses while game is running
void KeyDown(unsigned char key, int x, int y)
{
  int rc;

  if (key==controls.Thrust) {
    Ships[myShip]->Thrusting=1;
    KeyValues.ThrustKey=1;
    TellServer(THRUST_KEY, 1);
  } else if (key==controls.Left) {
    KeyValues.LeftKey=1;
    TellServer(LEFT_KEY, 1);
  } else if (key==controls.Right) {
    KeyValues.RightKey=1;
    TellServer(RIGHT_KEY, 1);
  } else if (key==controls.Fire) {
    KeyValues.FireKey=1;
    if (!GameOver || GameType!=SINGLE_PLAYER) {
      TellServer(FIRE_KEY, 1);
    } else {
      TellServer(ABORT_KEY, 1);
      GameStop=1;

      rc=pthread_join(ServerThread, NULL);
      if (!rc) {
	ReadServerConfig(ServerConfigFileName);
      }
      ReadConfig();

      if (CheckForHighScore()) {
	// If a high score is obtained, ask player to enter name for list
	playsound(HIGHSCORE);
	*HighScoreName=0;
	TextValue=HighScoreName;
	MaxTextLength=MAX_PLAYERNAME_LENGTH-1;
	Score=Ships[myShip]->score;
	pthread_mutex_unlock(ClientLock);
	pthread_join(readthread, NULL);
        glutKeyboardFunc(ScoreEntryKey);
	glutKeyboardUpFunc(NULL);
        glutSpecialFunc(NULL);
        glutIdleFunc(NULL);
        glutDisplayFunc(ScoreEntry);
	ScoreEntry();
      } else {
	pthread_mutex_unlock(ClientLock);
	pthread_join(readthread, NULL);
	glutKeyboardFunc(MainMenuKey);
	glutKeyboardUpFunc(NULL);
	glutSpecialFunc(MainMenuSpecialKey);
	glutIdleFunc(NULL);
	glutDisplayFunc(MainMenu);
	SetupMainMenuNames();
	MainMenu();
      }
    }
  } else if (key==controls.Shield) {
    KeyValues.ShieldKey=1;
    TellServer(SHIELD_KEY, 1);
  } else if (key==controls.Quit) {
    KeyValues.AbortKey=1;
    TellServer(ABORT_KEY, 1);
    GameStop=1;

    if (GameType==SINGLE_PLAYER) {
      rc=pthread_join(ServerThread, NULL);
      if (!rc) {
	ReadServerConfig(ServerConfigFileName);
      }
    }
    ReadConfig();

    pthread_mutex_unlock(ClientLock);
    pthread_join(readthread, NULL);
    glutKeyboardFunc(MainMenuKey);
    glutKeyboardUpFunc(NULL);
    glutSpecialFunc(MainMenuSpecialKey);
    glutIdleFunc(NULL);
    glutDisplayFunc(MainMenu);
    SetupMainMenuNames();
    MainMenu();
  } else if (key==controls.Score) {
    ShowScore=1;
  }
}


// Function to handle game releases while game is running
void KeyUp(unsigned char key, int x, int y)
{
  if (key==controls.Thrust) {
    Ships[myShip]->Thrusting=0;
    KeyValues.ThrustKey=0;
    TellServer(THRUST_KEY, 0);
  } else if (key==controls.Fire) {
    KeyValues.FireKey=0;
    TellServer(FIRE_KEY, 0);
  } else if (key==controls.Left) {
    KeyValues.LeftKey=0;
    TellServer(LEFT_KEY, 0);
  } else if (key==controls.Right) {
    KeyValues.RightKey=0;
    TellServer(RIGHT_KEY, 0);
  } else if (key==controls.Shield) {
    KeyValues.ShieldKey=0;
    TellServer(SHIELD_KEY, 0);
  } else if (key==controls.Score) {
    ShowScore=0;
  }
}


void MainMenuSpecialKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_UP:
    playsound(Bonk);
    MainMenuItemHighlighted--;
    if (MainMenuItemHighlighted < 0) {
      MainMenuItemHighlighted=NUM_MAINMENU_ITEMS-1;
    }
    break;
  case GLUT_KEY_DOWN:
    playsound(Bonk);
    MainMenuItemHighlighted++;
    if (MainMenuItemHighlighted >= NUM_MAINMENU_ITEMS) {
      MainMenuItemHighlighted=0;
    }
    break;
  }
  SetupMainDisplay();
  MainMenu();
}


void ConfMenuSpecialKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_UP:
    playsound(Bonk);
    ConfMenuItemHighlighted--;
    if (ConfMenuItemHighlighted < 0) {
      ConfMenuItemHighlighted=NUM_CONFMENU_ITEMS-1;
    }
    break;
  case GLUT_KEY_DOWN:
    playsound(Bonk);
    ConfMenuItemHighlighted++;
    if (ConfMenuItemHighlighted >= NUM_CONFMENU_ITEMS) {
      ConfMenuItemHighlighted=0;
    }
    break;
  }
  SetupConfDisplay();
  ConfMenu();
}


void ServMenuSpecialKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_UP:
    playsound(Bonk);
    ServMenuItemHighlighted--;
    if (ServMenuItemHighlighted < 0) {
      ServMenuItemHighlighted=NUM_SERVMENU_ITEMS-1;
    }
    break;
  case GLUT_KEY_DOWN:
    playsound(Bonk);
    ServMenuItemHighlighted++;
    if (ServMenuItemHighlighted >= NUM_SERVMENU_ITEMS) {
      ServMenuItemHighlighted=0;
    }
    break;
  }
  SetupServDisplay();
  ServMenu();
}


void ScoreMenuSpecialKey(int key, int x, int y)
{
  switch (key) {
  case GLUT_KEY_UP:
    playsound(Bonk);
    ScoreMenuItemHighlighted--;
    if (ScoreMenuItemHighlighted < 0) {
      ScoreMenuItemHighlighted=NUM_SCOREMENU_ITEMS-1;
    }
    break;
  case GLUT_KEY_DOWN:
    playsound(Bonk);
    ScoreMenuItemHighlighted++;
    if (ScoreMenuItemHighlighted >= NUM_SCOREMENU_ITEMS) {
      ScoreMenuItemHighlighted=0;
    }
    break;
  }
  ScoreMenu();
}


void MainMenuKey(unsigned char key, int x, int y)
{
  if (key=='\r') {
    MainMenuItemSelected();
  }
}


void ConfMenuKey(unsigned char key, int x, int y)
{
  if (key=='\r') {
    ConfMenuItemSelected();
  }
}


void ServMenuKey(unsigned char key, int x, int y)
{
  if (key=='\r') {
    ServMenuItemSelected();
  }
}


void ScoreMenuKey(unsigned char key, int x, int y)
{
  if (key=='\r') {
    ScoreMenuItemSelected();
  }
}


void SetKeyValueKey(unsigned char key, int x, int y)
{
  *KeyValue=key;

  glutKeyboardFunc(ConfMenuKey);
  glutSpecialFunc(ConfMenuSpecialKey);
  glutIdleFunc(NULL);
  glutDisplayFunc(ConfMenu);
  SetupConfMenuNames();
  ConfMenu();
}


void TextEntryKey(unsigned char key, int x, int y)
{
  int i;

  if (key=='\b') {
    i=strlen(TextValue);
    *(TextValue+i-1)=0;
    TextEntry();
  } else if (key=='\r') {
    glutKeyboardFunc(ConfMenuKey);
    glutSpecialFunc(ConfMenuSpecialKey);
    glutIdleFunc(NULL);
    glutDisplayFunc(ConfMenu);
    SetupConfMenuNames();
    ConfMenu();
  } else {
    i=strlen(TextValue);
    if (i<MaxTextLength) {
      *(TextValue+i)=key;
      *(TextValue+i+1)=0;
    }
    TextEntry();
  }
}


void ScoreEntryKey(unsigned char key, int x, int y)
{
  int i;

  if (key=='\b') {
    i=strlen(TextValue);
    *(TextValue+i-1)=0;
    ScoreEntry();
  } else if (key=='\r') {
    playsound(LuckySound);
    AddHighScore(TextValue);
    glutKeyboardFunc(ScoreMenuKey);
    glutSpecialFunc(ScoreMenuSpecialKey);
    glutIdleFunc(NULL);
    glutDisplayFunc(ScoreMenu);
    ScoreMenu();
  } else {
    i=strlen(TextValue);
    if (i<MaxTextLength) {
      *(TextValue+i)=key;
      *(TextValue+i+1)=0;
    }
    ScoreEntry();
  }
}


void IntTextEntryKey(unsigned char key, int x, int y)
{
  int i;
  char Value[80];

  sprintf(Value, "%d", *IntValue);

  if (key=='\b') {
    i=strlen(Value);
    *(Value+i-1)=0;
    *IntValue=atoi(Value);
    IntTextEntry();
  } else if (key=='\r') {
    glutKeyboardFunc(ConfMenuKey);
    glutSpecialFunc(ConfMenuSpecialKey);
    glutIdleFunc(NULL);
    glutDisplayFunc(ConfMenu);
    *IntValue=atoi(Value);
    if (NewScreenWidth!=ScreenWidth || NewScreenHeight!=ScreenHeight) {
      ScreenWidth=NewScreenWidth;
      ScreenHeight=NewScreenHeight;
      glutReshapeWindow(ScreenWidth, ScreenHeight);
    }
    SetupConfMenuNames();
    ConfMenu();
  } else if (key>='0' && key <='9') {
    i=strlen(Value);
    if (i<MaxTextLength) {
      *(Value+i)=key;
      *(Value+i+1)=0;
      *IntValue=atoi(Value);
    }
    IntTextEntry();
  }
}


void ServIntTextEntryKey(unsigned char key, int x, int y)
{
  int i;
  char Value[80];

  sprintf(Value, "%d", *IntValue);

  if (key=='\b') {
    i=strlen(Value);
    *(Value+i-1)=0;
    *IntValue=atoi(Value);
    IntTextEntry();
  } else if (key=='\r') {
    glutKeyboardFunc(ServMenuKey);
    glutSpecialFunc(ServMenuSpecialKey);
    glutIdleFunc(NULL);
    glutDisplayFunc(ServMenu);
    *IntValue=atoi(Value);
    SetupServMenuNames();
    ServMenu();
  } else if (key>='0' && key <='9') {
    i=strlen(Value);
    if (i<MaxTextLength) {
      *(Value+i)=key;
      *(Value+i+1)=0;
      *IntValue=atoi(Value);
    }
    IntTextEntry();
  }
}
