#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>


#include "defines.h"
#include "serverconfig.h"
#include "netconfig.h"
#include "servergame.h"
#include "serverdata.h"
#include "servership.h"
#include "mainplayerthread.h"
#include "readnetworkdata.h"
#include "thread.h"


pthread_t ServerThreads[MAX_PLAYERS+1];
ConnectionStruct Connections[MAX_PLAYERS];
pthread_mutex_t *ServerLock;
int GameStart;
int GamePort;
ServerObject *ServerObjects[MAX_OBJECTS];
int ObjSizes[NUM_TYPES];
int ObjWeights[NUM_TYPES];
int listenfd;
int StopServer;


void *Server(void *threadid)
{
  int rc, i;
  struct sockaddr_in servaddr;
  struct timeval timeout;

  for (i=0; i<MAX_PLAYERS; i++) {
    Connections[i].Connected=0;
  }
  NumConnectedPlayers=0;
  StopServer=0;

  if (!threadid) {
    ReadServerConfig(ServerSingleConfigFileName);
  }

  if ((listenfd=socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    printf("socket error\n");
    exit(3);
  }

  // Set a timeout of 2 seconds for listening
  timeout.tv_sec=2;
  timeout.tv_usec=0;
  setsockopt(listenfd, SOL_SOCKET, SO_RCVTIMEO,
	     &timeout, sizeof(struct timeval));

  memset(&servaddr, 0, sizeof(servaddr));
  servaddr.sin_family=AF_INET;
  servaddr.sin_addr.s_addr=htonl(INADDR_ANY);
  servaddr.sin_port=htons(GamePort);

  if (bind(listenfd, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0) {
    printf("bind error\n");
    exit(4);
  }

  if (!ServerLock) {
    ServerLock=(pthread_mutex_t *)malloc(sizeof(pthread_mutex_t));
    pthread_mutex_init(ServerLock, NULL);
  }

  // Spawn off the main game thread
  if (rc = pthread_create(&ServerThreads[MAX_PLAYERS], NULL,
			  StartGame, (void *)MAX_PLAYERS)) {
    printf("ERROR, return code from pthread_create() is %d\n", rc);
    exit(6);
  }

  ReadNetworkData();

  exit(7);
}
