#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>


#include "globals.h"
#include "object.h"
#include "star.h"
#include "sound.h"
#include "radar.h"


class Ship:public Object {

public:
  int Thrusting;
  int score;
  char ShieldOn;
  int alive;
  int Connected;
  int ExplodePhase;
  int playernum;
  char TripleShot;
  char LuckOfTheIrish;
  char AutoFire;
  char LongFire;
  char Speedup;
  char ShipName[MAX_PLAYERNAME_LENGTH];

  Ship(int index):Object(0, 0, 0)
  {
    sprite=ShipSprite;
    phase=0;
    score=0;
    playernum=index;
    ShieldOn=0;
    alive=0;
    sphase=0;
    ExplodePhase=0;
    OldPhase=0;
    ThrustSprite=Thrust1Sprite;
    oldxpos=0;
    oldypos=0;
    Thrusting=0;
    TripleShot=0;
    LuckOfTheIrish=0;
    AutoFire=0;
    LongFire=0;
    Speedup=0;
    Connected=0;
    *ShipName=0;
  }


  // Queue the ship to be displayed on the screen
  void ShowSprite(int xoffset, int yoffset)
  {
    int relxscreenpos, relyscreenpos;
    int relxworldpos, relyworldpos;
    int thrustx, thrusty;

    if (alive && !GameOver) {
      relxscreenpos=(xpos-xoffset)+ScreenWidth/2;
      if (relxscreenpos < 0) {
	relxscreenpos+=WorldWidth;
      } else if (relxscreenpos >= WorldWidth) {
	relxscreenpos-=WorldWidth;
      }
      relyscreenpos=(ypos-yoffset)+ScreenHeight/2;
      if (relyscreenpos < 0) {
	relyscreenpos+=WorldHeight;
      } else if (relyscreenpos >= WorldHeight) {
	relyscreenpos-=WorldHeight;
      }

      // Queue the ship to be displayed
      QueueSprite(relxscreenpos, relyscreenpos, sprite, phase);

      if (playernum!=myShip) {
	DrawText(relxscreenpos, relyscreenpos-10, ShipName, Blue);
      }

      relxworldpos=(xpos-xoffset)+WorldWidth/2;
      if (relxworldpos < 0) {
	relxworldpos+=WorldWidth;
      } else if (relxworldpos >= WorldWidth) {
	relxworldpos-=WorldWidth;
      }
      relyworldpos=(ypos-yoffset)+WorldHeight/2;
      if (relyworldpos < 0) {
	relyworldpos+=WorldHeight;
      } else if (relyworldpos >= WorldHeight) {
	relyworldpos-=WorldHeight;
      }

      // Draw the ship on the radar
      RadarDrawShip(relxworldpos, relyworldpos);

      // Queue the shield to be displayed if it is on
      if (ShieldOn) {
	QueueSprite(relxscreenpos, relyscreenpos, ShieldSprite, sphase);
	if (sphase) {
	  sphase=0;
	} else {
	  sphase=1;
	}
      }

      // Queue the thrust to be displayed if the ship is thrusting
      if (Thrusting) {
	thrustx=relxscreenpos+ThrustOrigins[phase].h;
	thrusty=relyscreenpos+ThrustOrigins[phase].v;
	QueueSprite(thrustx, thrusty, ThrustSprite, phase);

	if (ThrustSprite==Thrust1Sprite) {
	  if (playernum==myShip) {
	    playsound(ThrusterSound);
	  }
	  ThrustSprite=Thrust2Sprite;
	} else {
	  ThrustSprite=Thrust1Sprite;
	}
      }

      // Move the stars to show the motion of the player's ship
      if (playernum==myShip) {
	MoveStars(xpos-oldxpos, ypos-oldypos);
      }

      oldxpos=xpos;
      oldypos=ypos;
      OldPhase=phase;
    }
  }


protected:
  Sprite *ThrustSprite;
  int sphase;
  int OldPhase;
  int oldxpos, oldypos;
};
