#include "globals.h"
#include "sizes.h"
#include "screen.h"


Star StarArray[NUM_STARS];


// Function to initialize star array
void InitStars()
{
  int i, randint;
  float randfloat;

  for (i=0; i<NUM_STARS; i++) {
    randfloat=rand()%256+1;
    StarArray[i].StarColor.red=randfloat/256.0;
    randfloat=rand()%256+1;
    StarArray[i].StarColor.green=randfloat/256.0;
    randfloat=rand()%256+1;
    StarArray[i].StarColor.blue=randfloat/256.0;
    randint=rand()%ScreenWidth;
    StarArray[i].xpos=randint;
    randint=rand()%ScreenHeight;
    StarArray[i].ypos=randint;
  }
}


/*
  Function to move the stars against the motion of the ship.  This makes the
  ship appear to be moving through space.
*/
void MoveStars(int x, int y)
{
  int i;

  if (x > WorldWidth/2) {
    x-=WorldWidth;
  }
  if (x < -WorldWidth/2) {
    x+=WorldWidth;
  }
  if (y > WorldWidth/2) {
    y-=WorldHeight;
  }
  if (y < -WorldWidth/2) {
    y+=WorldHeight;
  }

  for (i=0; i<NUM_STARS; i++) {
    StarArray[i].xpos=(StarArray[i].xpos-x) % ScreenWidth;
    if (StarArray[i].xpos < 0) {
      StarArray[i].xpos+=ScreenWidth;
    }
    StarArray[i].ypos=(StarArray[i].ypos-y) % ScreenHeight;
    if (StarArray[i].ypos < 0) {
      StarArray[i].ypos+=ScreenHeight;
    }
  }
}


void DrawStars()
{
  int i;

  for (i=0; i<NUM_STARS; i++) {
    DrawPoint(StarArray[i].xpos, StarArray[i].ypos, StarArray[i].StarColor);
  }
}
