#include "ship.h"
#include "sizes.h"
#include "objglobals.h"
#include "radar.h"


unsigned long MaxShield;
unsigned long StatusHeight;
unsigned long ShieldPos;
unsigned long ShieldWidth;
unsigned long ShieldValue;
int Lives;
int ShowScore;


void UpdateShield();


void InitStatus()
{
  StatusHeight=32;
  ShieldWidth=60;
  ShieldValue=0;
}


// Function to draw the status on the bottom of the screen
void DrawStatus()
{
  int i;
  int spos=0, newspos;
  char Text[25+MAX_PLAYERNAME_LENGTH];

  // Draw status bar line
  DrawLine(0, StatusHeight, ScreenWidth, StatusHeight, White);

  // Draw box around radar
  if (GameType!=SINGLE_PLAYER) {
    DrawLine(ScreenWidth-RadarWidth, StatusHeight,
	     ScreenWidth-RadarWidth, StatusHeight+RadarHeight, White);
    DrawLine(ScreenWidth-RadarWidth, StatusHeight+RadarHeight,
	     ScreenWidth, StatusHeight+RadarHeight, White);
    DrawText(ScreenWidth-RadarWidth/2-14,
	     StatusHeight+RadarHeight-10, "Radar", Blue);
  }

  newspos = 3;
  spos = DrawText(newspos, StatusHeight/2+4, "Shield:", Blue) + 5;

  ShieldPos=spos+1;
  DrawLine(spos, StatusHeight/2+3, spos, StatusHeight-5, White);
  DrawLine(spos, StatusHeight-5, spos+ShieldWidth+2, StatusHeight-5, White);
  DrawLine(spos+ShieldWidth+2, StatusHeight-5,
	   spos+ShieldWidth+2, StatusHeight/2+3, White);
  DrawLine(spos+ShieldWidth+2, StatusHeight/2+3,
	   spos, StatusHeight/2+3, White);
  UpdateShield();

  spos = spos+ShieldWidth+20;
  if (GameType!=DEATHMATCH) {
    sprintf(Text, "Lives: %d", Lives-1);
    spos = DrawText(spos, StatusHeight/2+4, Text, Blue)+20;
  }

  if (Ships[myShip]->TripleShot) {
    QueueSprite(spos, StatusHeight/2+4, TripleIconSprite, 0);
  }
  spos+=15;
  if (Ships[myShip]->LuckOfTheIrish) {
    QueueSprite(spos, StatusHeight/2+4, LuckIconSprite, 0);
  }
  spos+=15;
  if (Ships[myShip]->AutoFire) {
    QueueSprite(spos, StatusHeight/2+4, AutoFireIconSprite, 0);
  }
  spos+=15;
  if (Ships[myShip]->LongFire) {
    QueueSprite(spos, StatusHeight/2+4, LongFireIconSprite, 0);
  }
  spos+=15;
  if (Ships[myShip]->Speedup) {
    QueueSprite(spos, StatusHeight/2+4, SpeedupIconSprite, 0);
  }

  if (GameType!=SINGLE_PLAYER) {
    sprintf(Text, "%s Score: %d", Ships[myShip]->ShipName,
	    Ships[myShip]->score);
    DrawText(3, 5, Text, Blue);
  } else {
    sprintf(Text, "Player Score: %d", Ships[myShip]->score);
    DrawText(3, 5, Text, Blue);
  }

  if (GameOver) {
    sprintf(Text, "Game Over");
    DrawText(ScreenWidth/2-7, ScreenHeight/2+20, Text, Blue);
    if (GameType!=SINGLE_PLAYER) {
      for (i=0; i<NumPlayers; i++) {
	if (Ships[i]->Connected) {
	  sprintf(Text, "%s Score: %d", Ships[i]->ShipName, Ships[i]->score);
	  DrawText(ScreenWidth/2-7, ScreenHeight/2-20*i, Text, Blue);
	}
      }
    } else {
      sprintf(Text, "Player Score: %d", Ships[myShip]->score);
      DrawText(ScreenWidth/2-7, ScreenHeight/2, Text, Blue);
      sprintf(Text, "Press Fire key to continue");
      DrawText(ScreenWidth/2-7, ScreenHeight/2-20, Text, Blue);
    }
  } else if (ShowScore && GameType!=SINGLE_PLAYER) {
    for (i=0; i<NumPlayers; i++) {
      if (Ships[i]->Connected) {
	sprintf(Text, "%s Score: %d", Ships[i]->ShipName, Ships[i]->score);
	DrawText(ScreenWidth/2-7, ScreenHeight-20*i-20, Text, Blue);
      }
    }
  }
}


// Function to update the shield value on the screen
void UpdateShield()
{
  int fract;

  fract = (ShieldWidth * ShieldValue) / MaxShield;

  DrawRect(ShieldPos+fract, StatusHeight/2+4, ShieldPos+fract, StatusHeight-6,
	   ShieldPos+ShieldWidth, StatusHeight-6,
	   ShieldPos+ShieldWidth, StatusHeight/2+4, Black);
  DrawRect(ShieldPos, StatusHeight/2+4, ShieldPos, StatusHeight-6,
	   ShieldPos+fract, StatusHeight-6,
	   ShieldPos+fract, StatusHeight/2+4, Blue);
}
